;******************************************************************
;***** VARIABLE DEFINITIONS and MACROS***********************
;******************************************************************
	 
	 cblock	0x20	;     20h.
	 place			; 
	 digit:3			;   
	 cnt_digit
	 mode
	 flags			;  
	 flags1          	;   
	 flags2
	 tmp_counter	;10
	 tmp
	 H_byte		;  AD   
	 L_byte  		;  AD 
	 H_sum			;   AD 
	 L_sum			;   AD 
	 Usum_H		
	 Usum_L	
	 Tsum_H		
	 Tsum_L
	 speed_repeat
	 ratio
	 digit_u:3
	 digit_t:3		;
	 figure:4		;32
	 sp_u
	 sp_t:2
	 sp_h:3
	 sp_tmp:3	
	 Fig:3
	 mask:3			
	 Err
	 r_sim
	 r_dec
	 hister
	 n_param
	 n_short_param	
	 step			;50
	 input
	 DS_DAT
	 current_place
	 count_impuls
	 Seg_kod
	 sp_th	
	 count_sampl	;  
	 count_sampl2	;  
	 				
	 mins_10		; 
       hours_10		; 		60
       count_tmr       	;  
             
       count_min       	;   	
       count_sec       	;   
	 count_hour		;  	
	
	 cnt
	 cnt_1
	 cnt1			;  3 
	 cnt2
	 cnt3
	 cnt_off
	
	SEG_10K
	SEG_1K		;70
	SEG_100
	SEG_10
	SEG_1
	BIT_H
	BIT_L			;75		
	endc		
			cblock	0x7B
			 w_temp              ; variable used for context saving 
			 status_temp         ; variable used for context saving
			 pclath_temp   	  	; variable used for context saving
			 fsr_temp	  		; 99
			 ee_size 			;    ( eeprom)
			 endc

#define	knopka		PORTA,5		; -  
#define	AD_start	ADCON0, 2	; A/D 
#define	DQ			PORTA, 3		; DS1820
#define	Duty_cycle CCPR1L	
		
#define	big_cykle	flags,0		;  
#define	short_flag	flags,1		;  : 0-long, 1-short
#define	min_elapsed	flags,2		; 1  
#define flash		flags,3		;   
#define	secunda	flags,4
#define	long_flag	flags,5		;   0-short, 1-long
#define	mode_off	flags,6		;1-off, 0-on
#define	sav_on		flags,7		; SET

#define	hours10_elapsed	flags1,0		; 10  
#define	kn_press1	flags1,1		; 1 
#define mode_set	flags1,2		; 0-, 1- 
#define	kn_off		flags1,3		; -   off
#define	inter_f		flags1,4		; 
#define	knopka1	flags1,5		; 1
#define	kn_press2	flags1,6		; 2 
#define	reset_oh	flags1,7

#define	kn_press3	flags2,0		; 2 
#define	kn_enable	flags2,1		;  +  -
#define	displ_off	flags2,2		; 
#define	edit_on		flags2,3		; 
#define	long_flag3	flags2,4		; 
#define	over_time	flags2,5		; 
#define	SU_on		flags2,6		;  2
#define	SU_off		flags2,7		;  2

#define	Off_interrupt		bcf	INTCON,GIE		; 
#define	On_interrupt		bsf	INTCON,GIE		; 

;*************************************	****************************
Off_Out	macro
			bsf      	STATUS,RP0	;bank 1
			bsf		CMCON, 0		;comparator off
			bsf		PIE1, TMR1IE
			bcf      	STATUS,RP0	;bank 0
			endm
				  
On_Out	macro
			bsf      	STATUS,RP0	;bank 1
			bcf		CMCON, 0	;comparator on
			bcf		PIE1, TMR1IE
			bcf      	STATUS,RP0	;bank 0
			bsf		T1CON, TMR1ON	; 1
			bcf		PIR1, TMR1IF			;  
			endm			
			
BANK0    MACRO  
		 BCF      STATUS,RP1  
		 BCF      STATUS,RP0  
		 ENDM
		
BANK1    MACRO  
		 BCF      STATUS,RP1  
		 BSF      STATUS,RP0  
		 ENDM
		;
;BANK2    MACRO  
;		 BSF      STATUS,RP1  
;		 BCF      STATUS,RP0  
;		 ENDM
		;
BANK3    MACRO  
		 BSF      STATUS,RP1  
		 BSF      STATUS,RP0  
		 ENDM


PAUSE_0.5S		macro
				movlw 	.1
		            movwf 	cnt1
		            call		delay_da
		            endm	             
;***************************************************************
;;------------------------------------------------------------------------								
PUSH	macro			;  W & STATUS
	movwf	w_temp		; Save WREG
	movf	STATUS,W	; Save STATUS
	movwf	status_temp
	movf	PCLATH, W
	movwf	pclath_temp
	movf	FSR, W
	movwf	fsr_temp
	endm			;
;***************************************************************
POP	macro			;  W & STATUS
	movf    fsr_temp, W		; restore the FSR
	movwf   FSR
	movf	pclath_temp, W
	movwf	PCLATH
	movf   	status_temp, W	;Swap original status register value into W
	movwf   STATUS		;Restore status register from W register
	swapf   w_temp, F	;Swap _WREG nibbles and return to _WREG
	swapf   w_temp, W	;Swap _WREG to W to restore original W value
	endm
;*****************************************************************
movf_f     MACRO SOURCE1,DEST1      ;  -
	movf    SOURCE1,W
	movwf   DEST1
	endm
movf_ff     MACRO SOURCE1,DEST1,DEST2      ;  --
	movf    SOURCE1,W
	movwf   DEST1
	movwf   DEST2
	endm
load_f     MACRO CONST2,DEST2      ;    
	movlw   CONST2
	movwf   DEST2
	endm			         
MASKA_F     	macro reg, dest       ;  
				movfw   reg
				xorwf   dest
				endm

INCR		macro	F
			local	Lab
			movfw	F
			addlw	-9
			BZ		Lab
			incf		F,f
			return
Lab			clrf		F
			endm

INCR5		macro	F
			local	Lab
			movfw	F
			addlw	-5
			BZ		Lab
			incf		F,f
			return
Lab			clrf		F
			endm

DECR		macro	F
			local	Lab
			movf	F,f
			BZ		Lab
			decf	F,f
			return
Lab			movlw	9
			movwf	F
			endm

DECR5		macro	F
			local	Lab
			movf	F,f
			BZ		Lab
			decf	F,f
			return
Lab			movlw	5
			movwf	F
			endm	
